//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
   Sound1= NULL;
   Sound2= NULL;
   Sound3= NULL;
   SoundInitialized= false;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
   if (DirectSoundCreate (NULL, &lpDS, NULL) != DS_OK)
     ErrorOut ("Cannot create DirectSound object.");
   if (lpDS->SetCooperativeLevel (Handle, DSSCL_NORMAL) != DS_OK )
     ErrorOut ("Cannot set cooperative level.");

   Sound1=SndObjCreate (lpDS, "Sound1", 1);
   Sound2=SndObjCreate (lpDS, "Sound2", 1);
   Sound3=SndObjCreate (lpDS, "Sound3", 1);

   SoundInitialized= true;

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SoundButton1Click(TObject *Sender)
{
  SndObjStop (Current);
  Current= Sound1;
  if (Looping->Checked)
    SndObjPlay (Sound1, DSBPLAY_LOOPING);
  else
    SndObjPlay (Sound1, 0);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SoundButton2Click(TObject *Sender)
{
  SndObjStop (Current);
  Current= Sound2;
  if (Looping->Checked)
    SndObjPlay (Sound2, DSBPLAY_LOOPING);
  else
    SndObjPlay (Sound2, 0);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::SoundButton3Click(TObject *Sender)
{
  SndObjStop (Current);
  Current= Sound3;
  if (Looping->Checked)
    SndObjPlay (Sound3, DSBPLAY_LOOPING);
  else
    SndObjPlay (Sound3, 0);

}
//---------------------------------------------------------------------------
void __fastcall TForm1::StopButtonClick(TObject *Sender)
{
  SndObjStop (Current);
  	
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
  if (lpDS)
  {
    SndObjDestroy (Sound1);
    Sound1=NULL;
    SndObjDestroy (Sound2);
    Sound2=NULL;
    SndObjDestroy (Sound3);
    Sound3=NULL;
    Current= NULL;
    lpDS->Release();
    lpDS=NULL;
  }

}
//---------------------------------------------------------------------------
void TForm1::ErrorOut (AnsiString Reason)
{
  Application->MessageBox ("DirectSound Error", Reason.c_str(), MB_OK);
  Close();
}

